#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_ControllerEventType
#include <snow/platform/native/input/sdl/ControllerEventType.h>
#endif
#ifndef INCLUDED_snow_platform_native_input_sdl_GamepadEventTypes
#include <snow/platform/native/input/sdl/GamepadEventTypes.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

Void GamepadEventTypes_obj::__construct()
{
	return null();
}

//GamepadEventTypes_obj::~GamepadEventTypes_obj() { }

Dynamic GamepadEventTypes_obj::__CreateEmpty() { return  new GamepadEventTypes_obj; }
hx::ObjectPtr< GamepadEventTypes_obj > GamepadEventTypes_obj::__new()
{  hx::ObjectPtr< GamepadEventTypes_obj > result = new GamepadEventTypes_obj();
	result->__construct();
	return result;}

Dynamic GamepadEventTypes_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< GamepadEventTypes_obj > result = new GamepadEventTypes_obj();
	result->__construct();
	return result;}

int GamepadEventTypes_obj::ge_axis;

int GamepadEventTypes_obj::ge_button_down;

int GamepadEventTypes_obj::ge_button_up;

int GamepadEventTypes_obj::ge_added;

int GamepadEventTypes_obj::ge_removed;

int GamepadEventTypes_obj::ge_remapped;

::snow::platform::native::input::sdl::ControllerEventType GamepadEventTypes_obj::typed( int ge_type){
	HX_STACK_FRAME("snow.platform.native.input.sdl.GamepadEventTypes","typed",0x21be441e,"snow.platform.native.input.sdl.GamepadEventTypes.typed","snow/platform/native/input/sdl/InputSystem.hx",360,0x01aafc86)
	HX_STACK_ARG(ge_type,"ge_type")
	HX_STACK_LINE(362)
	if (((ge_type == ::snow::platform::native::input::sdl::GamepadEventTypes_obj::ge_axis))){
		HX_STACK_LINE(362)
		return ::snow::platform::native::input::sdl::ControllerEventType_obj::axis;
	}
	HX_STACK_LINE(363)
	if (((ge_type == ::snow::platform::native::input::sdl::GamepadEventTypes_obj::ge_button_down))){
		HX_STACK_LINE(363)
		return ::snow::platform::native::input::sdl::ControllerEventType_obj::button_down;
	}
	HX_STACK_LINE(364)
	if (((ge_type == ::snow::platform::native::input::sdl::GamepadEventTypes_obj::ge_button_up))){
		HX_STACK_LINE(364)
		return ::snow::platform::native::input::sdl::ControllerEventType_obj::button_up;
	}
	HX_STACK_LINE(365)
	if (((ge_type == ::snow::platform::native::input::sdl::GamepadEventTypes_obj::ge_added))){
		HX_STACK_LINE(365)
		return ::snow::platform::native::input::sdl::ControllerEventType_obj::added;
	}
	HX_STACK_LINE(366)
	if (((ge_type == ::snow::platform::native::input::sdl::GamepadEventTypes_obj::ge_removed))){
		HX_STACK_LINE(366)
		return ::snow::platform::native::input::sdl::ControllerEventType_obj::removed;
	}
	HX_STACK_LINE(367)
	if (((ge_type == ::snow::platform::native::input::sdl::GamepadEventTypes_obj::ge_remapped))){
		HX_STACK_LINE(367)
		return ::snow::platform::native::input::sdl::ControllerEventType_obj::remapped;
	}
	HX_STACK_LINE(369)
	return ::snow::platform::native::input::sdl::ControllerEventType_obj::unknown;
}


STATIC_HX_DEFINE_DYNAMIC_FUNC1(GamepadEventTypes_obj,typed,return )


GamepadEventTypes_obj::GamepadEventTypes_obj()
{
}

Dynamic GamepadEventTypes_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"typed") ) { return typed_dyn(); }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"ge_axis") ) { return ge_axis; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"ge_added") ) { return ge_added; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"ge_removed") ) { return ge_removed; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"ge_remapped") ) { return ge_remapped; }
		break;
	case 12:
		if (HX_FIELD_EQ(inName,"ge_button_up") ) { return ge_button_up; }
		break;
	case 14:
		if (HX_FIELD_EQ(inName,"ge_button_down") ) { return ge_button_down; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic GamepadEventTypes_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 7:
		if (HX_FIELD_EQ(inName,"ge_axis") ) { ge_axis=inValue.Cast< int >(); return inValue; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"ge_added") ) { ge_added=inValue.Cast< int >(); return inValue; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"ge_removed") ) { ge_removed=inValue.Cast< int >(); return inValue; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"ge_remapped") ) { ge_remapped=inValue.Cast< int >(); return inValue; }
		break;
	case 12:
		if (HX_FIELD_EQ(inName,"ge_button_up") ) { ge_button_up=inValue.Cast< int >(); return inValue; }
		break;
	case 14:
		if (HX_FIELD_EQ(inName,"ge_button_down") ) { ge_button_down=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void GamepadEventTypes_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("ge_axis"),
	HX_CSTRING("ge_button_down"),
	HX_CSTRING("ge_button_up"),
	HX_CSTRING("ge_added"),
	HX_CSTRING("ge_removed"),
	HX_CSTRING("ge_remapped"),
	HX_CSTRING("typed"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::ge_axis,"ge_axis");
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::ge_button_down,"ge_button_down");
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::ge_button_up,"ge_button_up");
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::ge_added,"ge_added");
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::ge_removed,"ge_removed");
	HX_MARK_MEMBER_NAME(GamepadEventTypes_obj::ge_remapped,"ge_remapped");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::ge_axis,"ge_axis");
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::ge_button_down,"ge_button_down");
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::ge_button_up,"ge_button_up");
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::ge_added,"ge_added");
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::ge_removed,"ge_removed");
	HX_VISIT_MEMBER_NAME(GamepadEventTypes_obj::ge_remapped,"ge_remapped");
};

#endif

Class GamepadEventTypes_obj::__mClass;

void GamepadEventTypes_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.GamepadEventTypes"), hx::TCanCast< GamepadEventTypes_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void GamepadEventTypes_obj::__boot()
{
	ge_axis= (int)1616;
	ge_button_down= (int)1617;
	ge_button_up= (int)1618;
	ge_added= (int)1619;
	ge_removed= (int)1620;
	ge_remapped= (int)1621;
}

} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
